package vedran.mobookpacker;

import java.awt.Component;
import java.awt.Dimension;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.BufferedInputStream;
import java.io.BufferedOutputStream;
import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.FilenameFilter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStream;
import java.io.PrintWriter;
import java.util.Arrays;
import java.util.zip.ZipEntry;
import java.util.zip.ZipInputStream;
import java.util.zip.ZipOutputStream;

import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JComboBox;
import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JTextField;
import javax.swing.filechooser.FileFilter;

/*
 * Copyright 2005 Vedran Vidovic (vvidovic@inet.hr)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

/**
 * @author Administrator
 *
 * To change this generated comment edit the template variable "typecomment":
 * Window>Preferences>Java>Templates. To enable and disable the creation of type
 * comments go to Window>Preferences>Java>Code Generation.
 */
public class MainFrame extends JFrame implements ActionListener {
    private JFileChooser jfcCoverImage = new JFileChooser(".");

    private JFileChooser jfcTargetPath = new JFileChooser(".");

    private JFileChooser jfcBook = new JFileChooser(".");

    private GridBagLayout gbly = new GridBagLayout();

    private GridBagConstraints cnstr = new GridBagConstraints();

    private JButton jbtnHelp = new JButton("help");

    private JLabel jlblMidletName = new JLabel("Midlet (book) name: ");

    private JTextField jtfMidletName = new JTextField();

    private JLabel jlblCoverPath = new JLabel("Choose cover image (png): ");

    private JTextField jtfCoverPath = new JTextField("");

    private JButton jbtnCoverPath = new JButton("set");

    private JLabel jlblMidletFilesPath = new JLabel("Choose target dir: ");

    private JTextField jtfMidletFilesPath = new JTextField(new File("")
            .getAbsolutePath());

    private JButton jbtnMidletFilesPath = new JButton("set");

    private JLabel jlblBookPath = new JLabel("Choose book txt file: ");

    private JTextField jtfBookPath = new JTextField(new File("")
            .getAbsolutePath());

    private JButton jbtnBookPath = new JButton("set");

    private JLabel jlblBookEncoding = new JLabel("Choose book encoding: ");

    private JTextField jtfBookEncoding = new JTextField("");

    private JLabel jlblAutosave = new JLabel("Autosave book (minutes): ");
    
    private JTextField jtfAutosave = new JTextField("10");
    
    private JCheckBox jchbMax1Blank = new JCheckBox("Max 1 blank line", false);

    private JCheckBox jchbSkipSingleNewline = new JCheckBox(
            "Skip single new line chars", false);
    
    private JCheckBox jchbCreateJadFiles = new JCheckBox(
        "Create jad files", false);

    private JLabel jlblMaxJarFileSize = new JLabel("Max jar file size:");

    private JTextField jtfMaxJarFileSize = new JTextField("64", 10);

    private JComboBox jcbMaxJarFileSizeUnits = new JComboBox(new String[] {
            "B", "KB", "MB" });

    private JCheckBox jchbSplitJarJadFiles = new JCheckBox(
            "Split jar/jad files", false);

    private JButton jbtnCreate = new JButton("create MIDlet");

    private static final String VERSION = "2.5"; // trenutna verzija je 2.4... ostavi 2.5 kada nešto mijenjas...

    private static final String strHelp = "MoBookPacker ver. "
            + VERSION
            + "\n\n"
            + "This program is used to make book viewable on mobile devices supporting J2ME MIDP 1.0.\n"
            + "It packs your plain txt file with MoBook MIDlet which can be uploaded to mobile device\n"
            + "as any other mobile java application.\n\n"
            + "USAGE:\n"
            + "1. (Optional) Set name which will be used for packed MIDlet (if empty, text file name will be used).\n"
            + "2. Choose target dir where to put jad and jar files.\n"
            + "3. Choose plain txt file which will be displayed in MIDlet\n"
            + "(or use /path/to/dir/*.suffix notation to create more books).\n"
            + "4. (Optional) Choose book cover image (png format!).\n"
            + "5. (Optional) Enter book encoding (UTF-8,..). Text file which is packed have to be\n"
            + "   saved in entered encoding and mobile device have to support same encoding.\n"
            + "   If mobile device doesn't support this encoding it will read text file using it's\n"
            + "   default encoding.\n"
            + "6. (Optional) Enter book autosave value in minutes to ensure reading position and\n"
            + "   other book settings are saved in case of unexpected turn off of mobile device.\n"
            + "   Value of '0' or empty field ('') turns off autosave feature.\n"
            + "7. Press 'create MIDlet' button to create jad and jar files in target dir.\n"
            + "8. (Optional) If you selected \"Split jar/jad files\" checkbox and windows with text are shown,\n"
            + "   set text cursor to positions where you want to split files.\n\n"
            + "OPTIONS:\n"
            + "First option enables you to convert multiple blank lines in text to single blank line.\n"
            + "Second option enables you to convert all single newline chars in text to space chars\n"
            + "(because text lines are any way reformated to fit on small screen of mobile device).\n"
            + "Third option enables you to create book jad file (by default only jar file is created).\n"
            + "Fourth option enables you to split book in more than one file automaticaly to avoid\n"
            + "problems with maximum jar files limit on your mobile phone.\n\n"
            + "LICENCE:\n"
            + "MoBook and MoBookPacker can be used on any number of devices (mobile and pc) but is\n"
            + "distributed on an 'AS IS' basis, WITHOUT WARRANTY OF ANY KIND,\n"
            + "either express or implied.\n\n"
            + "You can change them or use them inside your own programs, but in that case text with\n"
            + "note about usage of MoBook and/or MoBookPacker and name of their author have to be\n"
            + "easily reachable from within new programs.\n\n"
            + "Copyright (C) Vedran Vidovic 2009, all Rights Reserved.";

    // This is size which works with MoBookPacker version 1.4.
    private static final long EMPTY_BOOK_SIZE = 16000;

    public MainFrame() {
        super("MoBookPacker");
        setDefaultCloseOperation(EXIT_ON_CLOSE);
        setSize(new Dimension(600, 410));
        getRootPane().setDefaultButton(jbtnCreate);
        jfcCoverImage.setFileSelectionMode(JFileChooser.FILES_ONLY);
        jfcTargetPath.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
        jfcBook.setFileSelectionMode(JFileChooser.FILES_ONLY);

        jfcCoverImage.setAcceptAllFileFilterUsed(false);
        jfcCoverImage.setFileFilter(new FileFilter() {
            public boolean accept(File f) {
                if (f.isDirectory()
                        || f.getName().toLowerCase().endsWith("png")) {
                    return true;
                } else {
                    return false;
                }
            }

            public String getDescription() {
                return "PNG Image files";
            }
        });

        jbtnCreate.addActionListener(this);
        jbtnCoverPath.addActionListener(this);
        jbtnMidletFilesPath.addActionListener(this);
        jbtnBookPath.addActionListener(this);
        jbtnHelp.addActionListener(this);
        jchbSplitJarJadFiles.addActionListener(this);
        jcbMaxJarFileSizeUnits.setSelectedIndex(1);

        getContentPane().setLayout(gbly);

        jtfMidletName.setPreferredSize(new Dimension(240, 21));
        jtfCoverPath.setPreferredSize(new Dimension(240, 21));
        jtfMidletFilesPath.setPreferredSize(new Dimension(240, 21));
        jtfBookPath.setPreferredSize(new Dimension(240, 21));
        jtfBookEncoding.setPreferredSize(new Dimension(120, 21));
        jtfAutosave.setPreferredSize(new Dimension(120, 21));
        jbtnCoverPath.setPreferredSize(new Dimension(70, 21));
        jbtnMidletFilesPath.setPreferredSize(new Dimension(70, 21));
        jbtnBookPath.setPreferredSize(new Dimension(70, 21));
        jbtnHelp.setPreferredSize(new Dimension(70, 21));

        cnstr.fill = GridBagConstraints.BOTH;

        cnstr.anchor = GridBagConstraints.LINE_END;
        cnstr.insets.bottom = 20;
        cnstr.gridx = 3;
        cnstr.gridy = 0;
        // cnstr.gridwidth = GridBagConstraints.REMAINDER; //end row
        addComponent(jbtnHelp, cnstr);
        cnstr.insets.bottom = 0;

        // cnstr.gridwidth = GridBagConstraints.RELATIVE;
        cnstr.gridx = 0;
        cnstr.gridy++;
        addComponent(jlblMidletName, cnstr);
        // cnstr.gridwidth = GridBagConstraints.REMAINDER; //end row
        cnstr.gridx = 1;
        cnstr.gridwidth = 2;
        addComponent(jtfMidletName, cnstr);

        // cnstr.gridwidth = GridBagConstraints.RELATIVE;
        cnstr.gridwidth = 1;
        cnstr.gridx = 0;
        cnstr.gridy++;
        addComponent(jlblCoverPath, cnstr);
        cnstr.gridx = 1;
        cnstr.gridwidth = 2;
        addComponent(jtfCoverPath, cnstr);
        // cnstr.gridwidth = GridBagConstraints.REMAINDER; //end row
        cnstr.gridwidth = 1;
        cnstr.gridx = 3;
        addComponent(jbtnCoverPath, cnstr);

        // cnstr.gridwidth = GridBagConstraints.RELATIVE;
        cnstr.gridx = 0;
        cnstr.gridy++;
        addComponent(jlblMidletFilesPath, cnstr);
        cnstr.gridx = 1;
        cnstr.gridwidth = 2;
        addComponent(jtfMidletFilesPath, cnstr);
        // cnstr.gridwidth = GridBagConstraints.REMAINDER; //end row
        cnstr.gridwidth = 1;
        cnstr.gridx = 3;
        addComponent(jbtnMidletFilesPath, cnstr);

        // cnstr.gridwidth = GridBagConstraints.RELATIVE;
        cnstr.gridx = 0;
        cnstr.gridy++;
        addComponent(jlblBookPath, cnstr);
        cnstr.gridx = 1;
        cnstr.gridwidth = 2;
        addComponent(jtfBookPath, cnstr);
        // cnstr.gridwidth = GridBagConstraints.REMAINDER; //end row
        cnstr.gridx = 3;
        addComponent(jbtnBookPath, cnstr);

        cnstr.gridx = 0;
        cnstr.gridy++;
        addComponent(jlblBookEncoding, cnstr);
        cnstr.gridx = 1;
        cnstr.gridwidth = 1;
        addComponent(jtfBookEncoding, cnstr);
        
        cnstr.gridx = 0;
        cnstr.gridy++;
        addComponent(jlblAutosave, cnstr);
        cnstr.gridx = 1;
        cnstr.gridwidth = 1;
        addComponent(jtfAutosave, cnstr);

        // cnstr.gridwidth = GridBagConstraints.REMAINDER; //end row
        cnstr.gridx = 0;
        cnstr.gridy++;
        cnstr.gridwidth = 4;
        addComponent(jchbMax1Blank, cnstr);

        cnstr.gridx = 0;
        cnstr.gridy++;
        addComponent(jchbSkipSingleNewline, cnstr);

        cnstr.gridx = 0;
        cnstr.gridy++;
        addComponent(jchbCreateJadFiles, cnstr);
        
        cnstr.gridwidth = 1;
        cnstr.gridx = 0;
        cnstr.gridy++;
        addComponent(jlblMaxJarFileSize, cnstr);
        cnstr.gridx = 1;
        addComponent(jtfMaxJarFileSize, cnstr);
        cnstr.gridx = 2;
        addComponent(jcbMaxJarFileSizeUnits, cnstr);
        cnstr.gridx = 3;
        addComponent(jchbSplitJarJadFiles, cnstr);

        cnstr.gridwidth = 4;
        cnstr.insets.top = 20;
        cnstr.gridx = 0;
        cnstr.gridy++;
        addComponent(jbtnCreate, cnstr);
    }

    // INTERFACE ActionListener
    public void actionPerformed(ActionEvent ae) {
        if (ae.getSource() == jbtnCreate) {
            createMidletBook();
        } else if (ae.getSource() == jbtnCoverPath) {
            int result = jfcCoverImage.showOpenDialog(this);
            if (result == JFileChooser.APPROVE_OPTION) {
                File f = jfcCoverImage.getSelectedFile();
                jtfCoverPath.setText(f.getAbsolutePath());
            }
        } else if (ae.getSource() == jbtnMidletFilesPath) {
            int result = jfcTargetPath.showOpenDialog(this);
            if (result == JFileChooser.APPROVE_OPTION) {
                File f = jfcTargetPath.getSelectedFile();
                jtfMidletFilesPath.setText(f.getAbsolutePath());
            }
        } else if (ae.getSource() == jbtnBookPath) {
            int result = jfcBook.showOpenDialog(this);
            if (result == JFileChooser.APPROVE_OPTION) {
                File f = jfcBook.getSelectedFile();
                jtfBookPath.setText(f.getAbsolutePath());
            }
        } else if (ae.getSource() == jbtnHelp) {
            JOptionPane.showMessageDialog(this, strHelp, "About",
                    JOptionPane.INFORMATION_MESSAGE);
        } else if (ae.getSource() == jchbSplitJarJadFiles) {
            enableSplit(jchbSplitJarJadFiles.isSelected());
        }
    }

    // INTERFACE ActionListener

    private void enableSplit(boolean enable) {
        jchbSplitJarJadFiles.setSelected(enable);
        jlblMaxJarFileSize.setEnabled(enable);
        jtfMaxJarFileSize.setEnabled(enable);
        jcbMaxJarFileSizeUnits.setEnabled(enable);
    }
    
    private void createMidletBook(final File fTargetDir, final File fBook, boolean showFinishedMessage) {
      String strCoverPath = jtfCoverPath.getText();
      if (strCoverPath != null && strCoverPath.length() > 0) {
          File fCover = new File(jtfCoverPath.getText());
          if (!fCover.exists() || !fCover.isFile()
                  || !fCover.getName().toLowerCase().endsWith("png")) {
              strCoverPath = null;
              JOptionPane.showMessageDialog(this,
                  "wrong cover file path, skipping cover file!");
          }
      }
      String name = jtfMidletName.getText();
      if (name.length() == 0) {
          name = fBook.getName();
          int idxDot = name.lastIndexOf('.');
          if (idxDot != -1) {
              name = name.substring(0, idxDot);
          }
      }

      long splitSize = 0;
      if (jchbSplitJarJadFiles.isSelected()) {
          String strSplitSize = jtfMaxJarFileSize.getText();
          try {
              splitSize = Long.parseLong(strSplitSize);
              switch (jcbMaxJarFileSizeUnits.getSelectedIndex()) {
              case 1:
                  splitSize *= 1024;
                  break;
              case 2:
                  splitSize *= 1024 * 1024;
                  break;
              }
              if (splitSize < EMPTY_BOOK_SIZE) {
                  splitSize = 0;
                  enableSplit(false);
                  JOptionPane.showMessageDialog(this,
                          "Maximum jar file size have to be at least "
                                  + EMPTY_BOOK_SIZE
                                  + " B!\nDisabling splitting.");
              }
          } catch (NumberFormatException e) {
              e.printStackTrace();
          }
      }

      // /////////
      createMidlet(fTargetDir.getAbsolutePath(), fBook.getAbsolutePath(),
              strCoverPath, name, splitSize, showFinishedMessage);
      }

    private void createMidletBook() {
        File fTargetDir = new File(jtfMidletFilesPath.getText());
        if (fTargetDir.exists() && fTargetDir.isDirectory()) {
            File fBook = new File(jtfBookPath.getText());
            if (fBook.exists() && fBook.isFile()) {
              createMidletBook(fTargetDir, fBook, true);
            } 
            else if (fBook.getName().contains("*.")) {
              String booksDir = fBook.getAbsolutePath();
              final String suffix = booksDir.substring(booksDir.indexOf("*.") + 1);
              booksDir = booksDir.substring(0, booksDir.lastIndexOf('/'));
              File fBooksDir = new File(booksDir);
              if (fBooksDir.exists() && fBooksDir.isDirectory()) {
                File[] files = fBooksDir.listFiles(new FilenameFilter() {
                  public boolean accept(File dir, String name) {
                    if(name.endsWith(suffix)) {
                      return true;
                    }
                    
                    return false;
                  }
                });
                
                int result = 
                  JOptionPane.showConfirmDialog(
                      this, 
                      "Are you sure you want to create books from files:\n" + fBook.getAbsolutePath());
                
                if(result == JOptionPane.OK_OPTION) {
                  Arrays.sort(files);
                  for (int i = 0; i < files.length; i++) {
                    createMidletBook(fTargetDir, files[i], false);
                  }
                  JOptionPane.showMessageDialog(this, "Finnished!");
                }
              }
              else {
                JOptionPane.showMessageDialog(this,
                "please select directory which contains multiple text files to pack!");
              }
            }
            else {
                JOptionPane.showMessageDialog(this,
                        "please select text file to pack!");
            }
        } else {
            JOptionPane.showMessageDialog(this,
                    "please select target directory!");
        }
    }



    private void createMidlet(String targetDirPath, String bookPath, String coverPath,
            String bookName, long splitSize, boolean showFinishedMessage) {
        try {
            long jarSize;
            if(splitSize == 0) {
                jarSize = createMidlet(targetDirPath, bookPath, coverPath, bookName, 0, 0, 0);
            }
            else {
                jarSize = createMidlet(targetDirPath, bookPath, coverPath, bookName, 0, 0, 0);
                if(jarSize > splitSize) {
                    deleteJadJarFiles(targetDirPath, bookName, 0);
                    long txtFileSize = new File(bookPath).length();
                    int fileNo = 1;
                    long txtStartByte = 0;
                    long newTextSize = txtFileSize * (splitSize - EMPTY_BOOK_SIZE) / (jarSize - EMPTY_BOOK_SIZE);
                    long txtLengthBytes = txtStartByte + newTextSize;

                    boolean finnished = false;
                    // If our jar is bigger than max jar file size, try again.
                    // If our text is not finnished and jar file is not near split size, try again.
                    //while(jarSize > splitSize ||
                          //(jarSize + 1024 < splitSize && txtStartByte + txtLengthBytes < txtFileSize )) {
                    while(!finnished) {
                        jarSize = createMidlet(targetDirPath, bookPath, coverPath, bookName,
                                               fileNo, txtStartByte, txtLengthBytes);
                        // File too big, try again.
                        // File smaller or equal splitSize, but not more than 1K. User chooses exact place to split, next file.
                        // File smaller or equal splitSize, but more than 1K smaller. Try again.
                        // Last file, finnish.
                        if(jarSize > splitSize) {
                            txtLengthBytes -= 1024;
                        }
                        else if(jarSize + 1024 >= splitSize) {
                            StringBuffer sb = new StringBuffer();
                            BufferedInputStream bis =
                                new BufferedInputStream(new FileInputStream(bookPath));
                            bis.skip(txtStartByte);
                            int ch = bis.read();
                            long count = 1;
                            while(ch != -1 && count < txtLengthBytes) {
                                sb.append((char)ch);
                                ch = bis.read();
                                count++;
                            }
                            bis.close();

                            SplitPositionFrame frame = new SplitPositionFrame(this);
                            frame.setText(sb.toString());
                            frame.setVisible(true);

                            int caretPos = frame.getCaretPosition();
                            // not used in java version because we don't have this problem with java version
                            long newLineCount = 0;
                            // Problem is that caret and char pos are not same!
                            // Maybe only because of newline chars...
//                            bis = new BufferedInputStream(new FileInputStream(bookPath));
//                            bis.skip(txtStartByte);
//                            ch = bis.read();
//                            count = 1;
//                            int chLast = -1;
//                            while(ch != -1 && count <= caretPos + newLineCount + 1) {
//                                // Add one for each '0d 0a' newlines because we use only '0a' and
//                                // we got wrong number for char position.
//                                if(chLast == 0x0d && ch == 0x0a) {
//                                    newLineCount++;
//                                }
//                                chLast = ch;
//                                ch = bis.read();
//                                count++;
//                            }
//                            bis.close();

                            /*MessageBox.Show(caretPos +
                                           ", len = " + txtLengthBytes +
                                           ", caret + newlines: " + (caretPos + newLineCount) +
                                          ", caret: " + caretPos +
                                         ", count: " + count +
                                        ", newlinecount: " + newLineCount);*/

                            createMidlet(targetDirPath, bookPath, coverPath, bookName,
                                               fileNo, txtStartByte, caretPos + newLineCount);
                            //txtStartByte += txtLengthBytes;
                            txtStartByte += caretPos + newLineCount;
                            fileNo ++;
                        }
                        else if(jarSize + 1024 < splitSize &&
                                txtStartByte + txtLengthBytes < txtFileSize ) {
                            txtLengthBytes += 512;
                        }
                        else {
                            finnished = true;
                        }
                    }

                }
            }
            
            System.out.println("created midlet(s) from " + bookPath);
            if(showFinishedMessage) {
              JOptionPane.showMessageDialog(this, "Finnished!");
            }
        }
        catch (IOException e) {
            e.printStackTrace();
            JOptionPane.showMessageDialog(this, e.getMessage());
        }
    }

    private String createJarPath(String targetDirPath, String bookName, int fileNo) {
        return createJadJarPathBase(targetDirPath, bookName, fileNo) + ".jar";
    }
    private String createJadPath(String targetDirPath, String bookName, int fileNo) {
        return createJadJarPathBase(targetDirPath, bookName, fileNo) + ".jad";
    }
    private String createJadJarPathBase(String targetDirPath, String bookName, int fileNo) {
        String noSuffix = "";
        if(fileNo != 0) {
            noSuffix = String.valueOf(fileNo);
        }
        return targetDirPath + File.separator + bookName + noSuffix;
    }
    private void deleteJadJarFiles(String targetDirPath, String bookName, int fileNo) {
        new File(createJadPath(targetDirPath, bookName, fileNo)).delete();
        new File(createJarPath(targetDirPath, bookName, fileNo)).delete();
    }

    private long createMidlet(String targetDirPath, String bookPath, String coverPath,
            String bookName,
            int jarNo, long txtStartByte, long txtLengthBytes)
        throws IOException
    {
        long jarFileSize = 0;

        String jarPath = createJarPath(targetDirPath, bookName, jarNo);
        String jadPath = createJadPath(targetDirPath, bookName, jarNo);

        // Create new jar file in which we will pack book + mobook...
        FileOutputStream fos = new FileOutputStream(jarPath);
        BufferedOutputStream bos = new BufferedOutputStream(fos);
        ZipOutputStream zos = new ZipOutputStream(bos);

        String line;

        ZipInputStream zis = new ZipInputStream(getClass().getClassLoader().getResourceAsStream("MoBook.jar"));
        
        
        // create new entry for book
        ZipEntry zipEntryBook = new ZipEntry("book.txt");
        //zipEntryBook.setSize(fBook.length());
        zos.putNextEntry(zipEntryBook);
        BufferedInputStream bis =
            new BufferedInputStream(new FileInputStream(bookPath));
        bis.skip(txtStartByte);

        int ch = bis.read();
        int cntNewline = 0; // No of new lines read.
        boolean max1blank = jchbMax1Blank.isSelected();
        boolean skipSingleNewline = jchbSkipSingleNewline.isSelected();
        int lastCharWritten = 0;
        boolean lastCharWasNewline = false;
        int chLast = -1;

        long charCnt = 0;
        while(ch != -1 && (txtLengthBytes == 0 || charCnt < txtLengthBytes)) {
            // CR-LF variant, skip second char
            if(ch != 0x0a || chLast != 0x0d) {
                boolean newLineCurrent = false;
                if(ch == ' ' && lastCharWritten == ' ') {
                }
                else {
                    if(ch == 0x0a || ch == 0x0d) {
                        cntNewline++;
                        newLineCurrent = true;
                    }
                    else {
                        cntNewline = 0;
                    }

                    if(cntNewline == 0) {
                        if(skipSingleNewline && lastCharWasNewline) {
                            zos.write((byte)' ');
                        }
                        if(!skipSingleNewline || !lastCharWasNewline || ch != ' ') {
                            zos.write((byte)ch);
                        }
                        lastCharWritten = ch;
                    }
                    else if(cntNewline == 1) {
                        if(!skipSingleNewline) {
                            zos.write((byte)'\n');
                            lastCharWritten = ch;
                        }
                    }
                    else if(cntNewline == 2) {
                        zos.write((byte)'\n');
                        lastCharWritten = ch;
                        // Last newline was skipped in this cse
                        if(skipSingleNewline) {
                            zos.write((byte)'\n');
                            lastCharWritten = ch;
                        }
                    }
                    else { // cntNewline > 2
                        if(!max1blank) {
                            zos.write((byte)'\n');
                            lastCharWritten = ch;
                        }
                    }
                }
                lastCharWasNewline = newLineCurrent;
            }
            chLast = ch;
            ch = bis.read();
            charCnt++;
        }
        zos.closeEntry();
        bis.close();

        
        ZipEntry zipEntry = zis.getNextEntry();
        while(zipEntry != null) {
            if(!zipEntry.isDirectory()) {
                String entryName = zipEntry.getName();
                if(entryName.endsWith(".universal") ||
                    entryName.endsWith(".nokia")) {
                    entryName = entryName.substring(0, entryName.lastIndexOf('.'));
                }
                // Create new entry for every original entry, but change name for
                // our platform specific file.
                ZipEntry zipEntryNew = new ZipEntry(entryName);
                zipEntryNew.setComment(zipEntry.getComment());
                //zipEntryNew.CompressedSize = zipEntry.CompressedSize;
                zipEntryNew.setExtra(zipEntry.getExtra());
                zipEntryNew.setMethod(zipEntry.getMethod());
                zipEntryNew.setTime(zipEntry.getTime());

                zos.putNextEntry(zipEntryNew);
                if(zipEntry.getName().endsWith("MANIFEST.MF")) {
                    bis = new BufferedInputStream(zis);
                    BufferedReader br = new BufferedReader(new InputStreamReader(bis));

                    line = br.readLine();
                    while(line != null) {
                        if(line.startsWith("MIDlet-Name:")) {
                            String nameSuffix = "";
                            if(jarNo > 0) {
                                nameSuffix = String.valueOf(jarNo);
                            }
                            line = "MIDlet-Name: " + bookName + nameSuffix;
                        }
                        else if(line.startsWith("MIDlet-1:")) {
                          String nameSuffix = "";
                          if(jarNo > 0) {
                            nameSuffix = String.valueOf(jarNo);
                          }
                          line = "MIDlet-1: " + bookName + nameSuffix + ", /icon.png, mobook.MoBook";
                        }
                        
                        if(line.trim().length() > 0) {
                          writeLine(zos, line);
                        }
                        
                        line = br.readLine();
                    }
                    
                    // add book size to manifest
                    writeLine(zos, "Book-Size: " + zipEntryBook.getSize());
                }
                else {
                    int c = zis.read();
                    while(c != -1) {
                        zos.write((byte)c);
                        c = zis.read();
                    }
                }
                zos.closeEntry();
            }

            zipEntry = zis.getNextEntry();
        }
        zis.close();

        // create new entry for cover if fCover != null
        if(coverPath != null && coverPath.length() > 0) {
            ZipEntry zipEntryCover = new ZipEntry("cover.png");
            zos.putNextEntry(zipEntryCover);
            bis = new BufferedInputStream(new FileInputStream(coverPath));
            ch = bis.read();
            while(ch != -1) {
                zos.write((byte)ch);
                ch = bis.read();
            }
            zos.closeEntry();
            bis.close();
        }


        //zos.Flush();
        zos.close();

        // create jad file
        if(jchbCreateJadFiles.isSelected()) {
          BufferedInputStream bisMoBookJad = new BufferedInputStream(getClass().getClassLoader().getResourceAsStream("MoBook.jad"));
          BufferedReader sr = new BufferedReader(new InputStreamReader(bisMoBookJad));
          
          fos = new FileOutputStream(jadPath);
          bos = new BufferedOutputStream(fos);
          PrintWriter sw = new PrintWriter(bos);
          
          
          line = sr.readLine();
          
          boolean bookSizeExists = false;
          jarFileSize = new File(jarPath).length();
          while(line != null && line.length() != 0) {
            String nameSuffix = "";
            if(jarNo > 0) {
              nameSuffix = String.valueOf(jarNo);
            }
            if(line.startsWith("MIDlet-Name:")) {
              line = "MIDlet-Name: " + bookName + nameSuffix;
            }
            else if(line.startsWith("MIDlet-1:")) {
              line = "MIDlet-1: " + bookName + nameSuffix + ", /icon.png, mobook.MoBook";
            }
            else if(line.startsWith("MIDlet-Jar-URL:")) {
              line = "MIDlet-Jar-URL: " + bookName + nameSuffix + ".jar";
            }
            else if(line.startsWith("MIDlet-Jar-Size:")) {
              line = "MIDlet-Jar-Size: " + jarFileSize;
            }
            else if(line.startsWith("Book-Size:")) {
              line = "Book-Size: " + zipEntryBook.getSize();
              bookSizeExists = true;
            }
            
            sw.println(line);
            line = sr.readLine();
          }
          if(!bookSizeExists) {
            sw.println("Book-Size: " + zipEntryBook.getSize());
          }
          String bookEncoding = jtfBookEncoding.getText();
          if(bookEncoding != null && bookEncoding.length() > 0) {
            sw.println("Book-Encoding: " + bookEncoding);
          }
          String autosave = jtfAutosave.getText();
          if(autosave != null && autosave.length() > 0) {
            sw.println("Book-Autosave: " + autosave);
          }
          sw.println();
          sw.println();
          sw.close();
          sr.close();
        }

        return jarFileSize;
    }

    private void writeLine(OutputStream os, String line) throws IOException {
      char[] carr = line.toCharArray();
      for(int i=0; i<carr.length; i++) {
          os.write((byte)carr[i]);
      }
      os.write((byte)'\n');
    }
//    private void createMidletBook(File fTargetDir, File fBook, File fCover,
//            String midletName) {
//        try {
//            // Put book to jar file.
//            File fJarNew = new File(fTargetDir, midletName + ".jar");
//            FileOutputStream fos = new FileOutputStream(fJarNew);
//            ZipOutputStream zos = new ZipOutputStream(fos);
//
//            ZipInputStream zis;
//            ZipEntry zipEntry;
//
//            ClassLoader cl = getClass().getClassLoader();
//            InputStream is = cl.getResourceAsStream("MoBook.jar");
//            zis = new ZipInputStream(is);
//            zipEntry = zis.getNextEntry();
//            while (zipEntry != null) {
//                // If we want nokia specific file (PlatformSpecificCanvas),
//                // we have to copy only one of them, acording to checkbox
//                // selection,
//                // so we skip another one.
//                if ((jchbNokiaVersion.isSelected() && zipEntry.getName()
//                        .endsWith(".universal"))
//                        || (!jchbNokiaVersion.isSelected() && zipEntry
//                                .getName().endsWith(".nokia"))) {
//                } else if (!zipEntry.isDirectory()) {
//                    String entryName = zipEntry.getName();
//                    if (zipEntry.getName().endsWith(".universal")
//                            || zipEntry.getName().endsWith(".nokia")) {
//                        entryName = entryName.substring(0, entryName
//                                .lastIndexOf('.'));
//                    }
//                    // Create new entry for every original entry, but change
//                    // name for
//                    // our platform specific file.
//
//                    // ZipEntry zipEntryNew = new ZipEntry(zipEntry);
//                    ZipEntry zipEntryNew = new ZipEntry(entryName);
//                    zipEntryNew.setComment(zipEntry.getComment());
//                    zipEntryNew.setCompressedSize(zipEntry.getCompressedSize());
//                    // zipEntryNew.setCrc(zipEntry.getCrc());
//                    zipEntryNew.setExtra(zipEntry.getExtra());
//                    zipEntryNew.setMethod(zipEntry.getMethod());
//                    // zipEntryNew.setSize(zipEntry.getSize());
//                    zipEntryNew.setTime(zipEntry.getTime());
//
//                    zos.putNextEntry(zipEntryNew);
//                    if (zipEntry.getName().endsWith("MANIFEST.MF")) {
//                        InputStreamReader isr = new InputStreamReader(zis);
//                        BufferedReader br = new BufferedReader(isr);
//                        String line = br.readLine();
//                        while (line != null) {
//                            if (line.startsWith("MIDlet-Name:")) {
//                                line = "MIDlet-Name: " + midletName;
//                            }
//                            for (int i = 0; i < line.length(); i++) {
//                                zos.write(line.charAt(i));
//                            }
//                            zos.write('\n');
//                            line = br.readLine();
//                        }
//                    } else if ((jchbNokiaVersion.isSelected() && zipEntry
//                            .getName().endsWith(".universal"))
//                            || (!jchbNokiaVersion.isSelected() && zipEntry
//                                    .getName().endsWith(".nokia"))) {
//                        // If we want nokia specific file, we have to copy only
//                        // one of them...
//                    } else {
//                        int c = zis.read();
//                        while (c != -1) {
//                            zos.write(c);
//                            c = zis.read();
//                        }
//                    }
//                }
//
//                zos.closeEntry();
//                zipEntry = zis.getNextEntry();
//            }
//            zis.close();
//
//            // create new entry for book
//            ZipEntry zipEntryBook = new ZipEntry("book.txt");
//            // zipEntryBook.setSize(fBook.length());
//            zos.putNextEntry(zipEntryBook);
//            BufferedInputStream bis = new BufferedInputStream(
//                    new FileInputStream(fBook));
//            int c = bis.read();
//            int cntNewline = 0; // No of new lines read.
//            boolean max1blank = jchbMax1Blank.isSelected();
//            boolean skipSingleNewline = jchbSkipSingleNewline.isSelected();
//            int lastCharWritten = 0;
//            int lastCharRead = 0;
//            while (c != -1) {
//                // System.out.println("c: '" + (c == 10 || c == 13 ? ' ' :
//                // (char)c) + "' (" + c + ")");
//                if (c != 13) {
//                    if (c == ' ' && lastCharWritten == ' ') {
//                    } else {
//                        if (c == 10) {
//                            cntNewline++;
//                        } else {
//                            cntNewline = 0;
//                        }
//
//                        if (cntNewline == 0) {
//                            if (skipSingleNewline && lastCharRead == 10) {
//                                zos.write(' ');
//                            }
//                            if (!skipSingleNewline || lastCharRead != 10
//                                    || c != ' ') {
//                                zos.write(c);
//                            }
//                            lastCharWritten = c;
//                        } else if (cntNewline == 1) {
//                            if (!skipSingleNewline) {
//                                zos.write(c);
//                                lastCharWritten = c;
//                            }
//                        } else if (cntNewline == 2) {
//                            zos.write(c);
//                            lastCharWritten = c;
//                            // Last newline was skipped in this cse
//                            if (skipSingleNewline) {
//                                zos.write(c);
//                                lastCharWritten = c;
//                            }
//                        } else { // cntNewline > 2
//                            if (!max1blank) {
//                                zos.write(c);
//                                lastCharWritten = c;
//                            }
//                        }
//                    }
//                    lastCharRead = c;
//                }
//                c = bis.read();
//            }
//            zos.closeEntry();
//            bis.close();
//
//            // create new entry for cover if fCover != null
//            if (fCover != null) {
//                ZipEntry zipEntryCover = new ZipEntry("cover.png");
//                zos.putNextEntry(zipEntryCover);
//                bis = new BufferedInputStream(new FileInputStream(fCover));
//                c = bis.read();
//                while (c != -1) {
//                    zos.write(c);
//                    c = bis.read();
//                }
//                zos.closeEntry();
//                bis.close();
//            }
//
//            zos.close();
//            // fJarUnpacked.delete();
//
//            is = cl.getResourceAsStream("MoBook.jad");
//            InputStreamReader isr = new InputStreamReader(is);
//            BufferedReader br = new BufferedReader(isr);
//
//            File fJadNew = new File(fTargetDir, midletName + ".jad");
//            fos = new FileOutputStream(fJadNew);
//            OutputStreamWriter osw = new OutputStreamWriter(fos);
//            BufferedWriter bw = new BufferedWriter(osw);
//
//            String line = br.readLine();
//            boolean bookSizeExists = false;
//            while (line != null && !line.equals("")) {
//                if (line.startsWith("MIDlet-Name:")) {
//                    line = "MIDlet-Name: " + midletName;
//                } else if (line.startsWith("MIDlet-Jar-URL:")) {
//                    line = "MIDlet-Jar-URL: " + midletName + ".jar";
//                } else if (line.startsWith("MIDlet-Jar-Size:")) {
//                    line = "MIDlet-Jar-Size: " + fJarNew.length();
//                } else if (line.startsWith("Book-Size:")) {
//                    line = "Book-Size: " + zipEntryBook.getSize();
//                    bookSizeExists = true;
//                }
//                bw.write(line + "\n");
//                line = br.readLine();
//            }
//            if (!bookSizeExists) {
//                bw.write("Book-Size: " + zipEntryBook.getSize());
//            }
//            bw.write("\n\n");
//            bw.close();
//            br.close();
//        } catch (IOException e) {
//            e.printStackTrace();
//        } catch (Exception e) {
//            e.printStackTrace();
//        }
//    }

    private void addComponent(Component comp, GridBagConstraints c) {
        gbly.setConstraints(comp, c);
        getContentPane().add(comp);
    }

}
